commit 2b6cfe7c4ee98b2c38e6a6d98742f1efb2fc9a79
Author: Peter Bergner <bergner@linux.ibm.com>
Date:   Tue Nov 16 19:14:22 2021

    rs6000: MMA test case emits wrong code when building a vector pair [PR102976]
    
    PR102976 shows a test case where we generate wrong code when building
    a vector pair from 2 vector registers.  The bug here is that with unlucky
    register assignments, we can clobber one of the input operands before
    we write both registers of the output operand.  The solution is to use
    early-clobbers in the assemble pair and accumulator patterns.
    
    2021-11-16  Peter Bergner  <bergner@linux.ibm.com>
    
    gcc/
            PR target/102976
            * config/rs6000/mma.md (*vsx_assemble_pair): Add early-clobber for
            output operand.
            (*mma_assemble_acc): Likewise.
    
    gcc/testsuite/
            PR target/102976
            * gcc.target/powerpc/pr102976.c: New test.
    
    (cherry picked from commit 4cdf7db9a39d18bd536d816a5751d4d3cf23808b)

diff --git a/gcc/testsuite/gcc.target/powerpc/pr102976.c b/gcc/testsuite/gcc.target/powerpc/pr102976.c
new file mode 100644
index 00000000000..5a4320f8e0a
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/pr102976.c
@@ -0,0 +1,14 @@
+/* { dg-require-effective-target power10_ok } */
+/* { dg-options "-O2 -mdejagnu-cpu=power10" } */
+
+#include <altivec.h>
+void
+bug (__vector_pair *dst)
+{
+  register vector unsigned char vec0 asm ("vs44");
+  register vector unsigned char vec1 asm ("vs32");
+  __builtin_vsx_build_pair (dst, vec0, vec1);
+}
+
+/* { dg-final { scan-assembler-times {(?p)\mxxlor \d+,44,44\M} 1 } } */
+/* { dg-final { scan-assembler-times {(?p)\mxxlor \d+,32,32\M} 1 } } */

